## pplatex 1.0~beta2023.12.01.repack

=== CMakeLists.txt ===
#
# Author: Stefan Hepp <stefan@stefant.org>
#
# CMake build scripts for pplatex. 
#
# This is an alternative build script for the SCons based build script.
# It is recommended to build in a separate directory. Assuming this git
# repository has been checked out to 'pplatex', run:
#   mkdir ../build
#   cd ../build
#   cmake ../pplatex
#   make
#
# Requirements on Linux are:
# - pkg-config
# - libpcre3-dev
# Requirements on Windows are:
# - MSVC Compiler (should work with Cygwin/MinGW as well)
# - PCRE (statically linked)
#
# You can compile PCRE on Windows using cmake from the source distribution file.
# If you link with a dynamic PCRE library, remove the -DPCRE_STATIC definition in
# src/CMakeLists.txt
# 
# To compile on Windows, create a build directory and run cmake-gui <this-repo-dir> 
# in that build directory. Set PCRE_INCLUDE_DIR to the directory containing pcre.h, and
# set PCRE_PCREPOSIX_LIBRARY and PCRE_PCRE_LIBRARY to the pcreposix.lib and pcre.lib
# filename, respectively. Set the CMAKE_BUILD_TYPE to 'Release' (optional), and use the
# nmake or make generator, then run nmake (or make) in the build directory, after generating
# the build files.
#
# TODO: Adapt FindPCRE.cmake to choose static or dynamic linking via a CMake option
#       and set -DPCRE_STATIC accordingly.
#

# Minimum requirement is probably much lower, but lets say 3.0 for now.
cmake_minimum_required(VERSION 3.0)

# Main project name
project(pplatex)

# Load module to find PCRE
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Find and configure PCRE library
find_package(PCRE REQUIRED)

# Build pplatex
add_subdirectory(src)

=== SConstruct ===
import os
from conf import CppSetup
from conf import LatexSetup

vars = InitVariables(release=True)
CppSetup.AddVariables(vars)
LatexSetup.AddVariables(vars)

vars.Add(PathVariable('PCREPATH', 'Path of pcre library installation path.',None,PathVariable.PathAccept));
vars.Add(PathVariable('DESTDIR', 'Installation destination "/bin" path prefix.', '/usr', PathVariable.PathAccept))

env = DefaultEnvironment(variables=vars, ENV=CreateEnv(vars))
env.Tool('file')

LoadReleaseFile(env, 'RELEASE')

CppSetup.SetupEnv(env, console=True)
LatexSetup.SetupEnv(env)

if env['CC'] == 'cl':
    env.Append( CPPFLAGS=['/EHsc'] )
    # TODO if we link statically with PCRE on windows with MSVC, set PCRE_STATIC automatically, or make this an config option.
    #env.Append( CPPDEFINES=['PCRE_STATIC'] )

if env.get('PCREPATH', None) is not None:
    env.Append( LIBPATH=[ env['PCREPATH']+'/lib' ] )
    env.Append( CPPPATH=[ env['PCREPATH']+'/include' ] )
env.Append( LIBS=['pcreposix'] )

# Build the main program and copy it with different filenames
latex = SConscript("src/SConscript", variant_dir="obj", duplicate=0, exports="env")
pdftex = env.FileCopy("bin/ppdflatex"+env['PROGSUFFIX'], latex)
if env['PLATFORM'] == 'posix':
    # On linux, we use the shell script for luatex that supports a user config
    luatex = env.FileCopy("bin/ppluatex", "src/ppluatex")
else:
    # Otherwise, we just copy the binary again.
    luatex = env.FileCopy("bin/ppluatex"+env['PROGSUFFIX'], latex)


# For testing, run the .tex files in test/ through pplatex inside a temp directory
VariantDir('tmp', 'test', duplicate=1)
pdf = PDF('tmp/test.tex')
pdf2 = PDF('tmp/test_paren.tex')

# Install pplatex binaries
prefix = env.get('DESTDIR', '')
bindir = prefix + '/bin'
env.Install(bindir, [latex, pdftex, luatex])
Alias('install', bindir)

# Setup aliases and default target
Alias('app', [latex,pdftex,luatex] )
Alias('logs', [pdf,pdf2] )

Default('app')

Help(vars.GenerateHelpText(env))

=== src/CMakeLists.txt ===

# Link with PCRE
include_directories(${PCRE_INCLUDE_DIR})

# On Windows, assume we are linking statically
if (WIN32)
  add_definitions(-DPCRE_STATIC)
endif()

add_executable(pplatex main.cpp regex.cpp outputinfo.cpp
	               outputfilter.cpp
	               latexoutputfilter.cpp)

target_link_libraries(pplatex ${PCRE_LIBRARIES})

=== debian/changelog ===
pplatex (1.0~beta2023.12.01.repack-1) unstable; urgency=medium

  * Initial version (closes: #1057322)

 -- Sebastian Humenda <shumenda@gmx.de>  Tue, 28 Nov 2023 10:16:21 +0100

=== debian/control ===
Source: pplatex
Section: text
Priority: optional
Maintainer: Sebastian Humenda <shumenda@gmx.de>
Build-Depends: debhelper-compat (= 13), cmake, libpcre3-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/stefanhepp/pplatex
Vcs-Browser: https://salsa.debian.org/humenda-guest/pplatex
Vcs-Git: https://salsa.debian.org/humenda-guest/pplatex

Package: pplatex
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: parse latex logs and print warnings/errors in a human readable format
 LaTeX is able to produce really nice document layouts. But it is also able to
 produce a lot of noise on the command line.  `pplatex` is a command-line tool
 that parses the logs of latex and pdflatex and prints warnings and errors in
 a human readable format.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all


%:
	dh $@

override_dh_auto_clean:
	rm -f debian/pplatex.1
	dh_auto_clean
